void ReleaseAllObjects(void)
{
if(g_pDD!=NULL)
{
 if(g_pDDSPrimary!=NULL) {  g_pDDSPrimary->Release();  g_pDDSPrimary=NULL; }
 if(g_pDDSOne!=NULL) {  g_pDDSOne->Release();  g_pDDSOne=NULL; }
 if(g_pDDPal!=NULL) {  g_pDDPal->Release();  g_pDDPal=NULL; }
 g_pDD->Release();
 g_pDD=NULL;
 }
}

HRESULT InitFail(HWND hWnd,HRESULT hRet,LPCTSTR szError,...)
{
 char szBuff[128];
 va_list vl;
 va_start(vl,szError);
 vsprintf(szBuff,szError,vl);
 ReleaseAllObjects();
 MessageBox(hWnd,szBuff,"DDraw error",MB_OK);
 DestroyWindow(hWnd);
 va_end(vl);
 return hRet;
}

void UpdateFrame(HWND hWnd)
{
 RECT rcRect;
 RECT destRect;
 HRESULT hRet;
 POINT pt;
 DDSURFACEDESC2 ddsd;
 rcRect.left =0;
 rcRect.top = 0;
 rcRect.right = 160;
 rcRect.bottom = 144;
 GetClientRect(hWnd, &destRect);
 pt.x=pt.y=0;
 ClientToScreen(hWnd,&pt);
 OffsetRect(&destRect,pt.x,pt.y);
 g_pClipper->SetHWnd(0,window);
 memset(&ddsd,0,sizeof(ddsd));
 ddsd.dwSize=sizeof(ddsd);
 g_pDDSOne->Lock(NULL,&ddsd,DDLOCK_WAIT|DDLOCK_SURFACEMEMORYPTR,NULL);
 DWORD tmp0=(DWORD)(&dx_buffer[0]);
 DWORD aal=ddsd.lPitch*36;
 if(ddsd.lpSurface!=NULL)
  _asm
 {
  cld
  mov esi,tmp0
  mov edi,ddsd.lpSurface
  mov ecx,aal
  rep movsd
 }
 g_pDDSOne->Unlock(NULL);
 while(1)
 {
  hRet=g_pDDSPrimary->Blt(&destRect,g_pDDSOne,&rcRect,0,NULL);
  if(hRet==DD_OK)
   break;
  if(hRet==DDERR_SURFACELOST)
  {
   while(!(g_pDDSPrimary->Restore()==DD_OK&&g_pDDSOne->Restore()==DD_OK));
   return;
  }
  if (hRet != DDERR_WASSTILLDRAWING)
   return;
 }
 if (hRet != DD_OK)
 return;
}

int start_dx(void)
{
  LPDIRECTDRAW pDD;
  DDSURFACEDESC2 ddsd3;
  HRESULT hRet=DirectDrawCreate(NULL,&pDD,NULL);
  if(hRet!=DD_OK)
    return InitFail(window,hRet,"DirectDrawCreate FAILED");
  hRet=pDD->QueryInterface(IID_IDirectDraw4,(LPVOID *)&g_pDD);
  if(hRet!=DD_OK)
    return InitFail(window,hRet,"QueryInterface FAILED");
  hRet=g_pDD->SetCooperativeLevel(window,DDSCL_NORMAL);
  if(hRet!=DD_OK)
   return InitFail(window,hRet,"SetCooperativeLevel FAILED");
  DDSURFACEDESC2 ddsd;
  ZeroMemory(&ddsd,sizeof(ddsd));
  ddsd.dwSize=sizeof(ddsd);
  ddsd.dwFlags=DDSD_CAPS;
  ddsd.ddsCaps.dwCaps=DDSCAPS_PRIMARYSURFACE;
  hRet=g_pDD->CreateSurface(&ddsd,&g_pDDSPrimary,NULL);
  if(hRet!=DD_OK)
   return InitFail(window,hRet,"CreateSurface FAILED");
  hRet=g_pDD->CreateClipper(0,&g_pClipper,NULL);
  if(hRet!=DD_OK)
   return InitFail(window,hRet,"CreateClipper FAILED");
  hRet=g_pClipper->SetHWnd(0,window);
  if(hRet!=DD_OK)
   return InitFail(window,hRet,"SetHWnd FAILED");
  hRet=g_pDDSPrimary->SetClipper(g_pClipper);
  if(hRet!=DD_OK)
   return InitFail(window,hRet,"SetClipper FAILED");
  ZeroMemory(&ddsd3, sizeof(ddsd));
  ddsd3.dwSize=sizeof(ddsd);
  ddsd3.dwFlags=DDSD_CAPS|DDSD_HEIGHT|DDSD_WIDTH;
  ddsd3.ddsCaps.dwCaps=DDSCAPS_OFFSCREENPLAIN;
  ddsd3.dwWidth=160;
  ddsd3.dwHeight=200;
  if(g_pDD->CreateSurface(&ddsd3,&g_pDDSOne,NULL)!=DD_OK)
   return InitFail(window,hRet,"CBuffer FAILED");
  DDSURFACEDESC2 ddsd2;
  memset(&ddsd2,0,sizeof(ddsd2));
  ddsd2.dwSize =sizeof(ddsd2);
  ddsd2.dwFlags=DDSD_PIXELFORMAT ;
  Sleep(500);//*MAGIC*
  g_pDDSOne->Lock(NULL,&ddsd2,DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT,NULL);
  dx_bits=ddsd2.ddpfPixelFormat.dwRGBBitCount; 
  dx_r=ddsd2.ddpfPixelFormat.dwRBitMask; 
  dx_g=ddsd2.ddpfPixelFormat.dwGBitMask; 
  dx_b=ddsd2.ddpfPixelFormat.dwBBitMask; 
  dx_pitch=ddsd2.lPitch;
  cmov=ddsd2.lPitch/4;
  dx_bits/=8;
  dx_sr=find1(dx_r);
  dx_sg=find1(dx_g);
  dx_sb=find1(dx_b);
  dx_r=count1(dx_r);
  dx_g=count1(dx_g);
  dx_b=count1(dx_b);
  g_pDDSOne->Unlock(NULL);
}






































